/*Initialize variables that will be used later*/
int xspacing = 32;   // How far apart should each horizontal location be spaced
float amplitude = 75.0;  // Height of wave
float period = 500.0;    // How many pixels before the wave repeats
int w;                   // Width of entire wave
float dx;                // Value for incrementing X, a function of period and xspacing
int numPoints;           // # of points to draw for a wave

void setup() {
  size(640, 360);
  w = width+16;
  dx = (TWO_PI / period) * xspacing;  // TWO_PI is 2 * PI
  numPoints = w/xspacing;
}

void draw() {
  background(0);
  noStroke();
  fill(255);
  
  drawOneWave(0);  // draw one sine wave
  drawOneWave(2);  // draw another sine wave
}

/*
 * This method draws a sine wave.
 */
void drawOneWave(float angle) { 
  float x, y;
  float plot_x, plot_y;
 
  for (int i = 0; i < numPoints; i++) {
    // For every x value, calculate a y value with sine function
    x = angle + i * dx;
    y = sin(x) * amplitude;
    plot_x = i * xspacing;
    plot_y = height/2 + y;
    ellipse(plot_x, plot_y, 16, 16);
  }
}
